local f1 = CreateFrame("Frame","PlayerStats",UIParent,"BasicFrameTemplate")
local f2 = CreateFrame("Frame","CombatStats",UIParent,"BasicFrameTemplate")
local f3 = CreateFrame("Frame","QuestStats",UIParent,"BasicFrameTemplate")
local f4 = CreateFrame("Frame","TargetBar",UIParent,"BasicFrameTemplate")
local f5 = CreateFrame("Frame","ThreatBar",UIParent,"BasicFrameTemplate")
local f6 = CreateFrame("Frame","EquipStats",UIParent,"BasicFrameTemplate")
local f7 = CreateFrame("Frame","AdvancedBar",UIParent,"TooltipBorderedFrameTemplate")

local f9 = CreateFrame("Frame","SpellAreaBar",UIParent,"BasicFrameTemplate")
local s2 = CreateFrame("ScrollFrame","LeaderBar",f9,"UIPanelScrollFrameTemplate")
local f8 = CreateFrame("Frame","LeaderStats",s2,"InsetFrameTemplate2")

local b1 = CreateFrame("Button","TargetMob",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")
local b2 = CreateFrame("Button","TargetPlayer",UIParent,"SecureActionButtonTemplate, TooltipBorderedFrameTemplate")

local b4 = CreateFrame("Button","tStar",f4,"UIPanelButtonTemplate")
local b5 = CreateFrame("Button","tCircle",f4,"UIPanelButtonTemplate")
local b6 = CreateFrame("Button","tDiamond",f4,"UIPanelButtonTemplate")
local b7 = CreateFrame("Button","tTriangle",f4,"UIPanelButtonTemplate")
local b8 = CreateFrame("Button","tMoon",f4,"UIPanelButtonTemplate")
local b9 = CreateFrame("Button","tSquare",f4,"UIPanelButtonTemplate")
local b10 = CreateFrame("Button","tCross",f4,"UIPanelButtonTemplate")
local b11 = CreateFrame("Button","tSkull",f4,"UIPanelButtonTemplate")

local b12 = CreateFrame("Button","tPartyOne",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b13 = CreateFrame("Button","tPartyTwo",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b14 = CreateFrame("Button","tPartyThree",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b15 = CreateFrame("Button","tPartyFour",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b16 = CreateFrame("Button","tRaidFive",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b17 = CreateFrame("Button","tRaidSix",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b18 = CreateFrame("Button","tRaidSeven",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b19 = CreateFrame("Button","tRaidEight",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")
local b20 = CreateFrame("Button","tRaidNine",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")

local b40 = CreateFrame("Button","tCastRaid",f4,"SecureActionButtonTemplate, UIPanelButtonTemplate")

local b3 = CreateFrame("Button","pVendor",f7,"UIPanelButtonTemplate")
local b21 = CreateFrame("Button","pViewPlayer",f7,"UIPanelButtonTemplate")
local b22 = CreateFrame("Button","pViewCombat",f7,"UIPanelButtonTemplate")
local b23 = CreateFrame("Button","pViewQuests",f7,"UIPanelButtonTemplate")
local b24 = CreateFrame("Button","pViewTargets",f7,"UIPanelButtonTemplate")
local b25 = CreateFrame("Button","pViewStatSet",f7,"UIPanelButtonTemplate")
local b26 = CreateFrame("Button","pViewAdvance",f7,"UIPanelButtonTemplate")
local b27 = CreateFrame("Button","pViewLeader",f7,"UIPanelButtonTemplate")

local t1 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t2 = f1:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t3 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t5 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t8 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")
local t9 = f2:CreateFontString(nil,"OVERLAY","NumberFontNormalLarge")

local t6 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t16 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t17 = f3:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t18 = f5:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t10 = b1:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t11 = b1:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local t12 = b2:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t13 = b2:CreateFontString(nil,"OVERLAY","GameFontNormalHuge")

local t19 = f6:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t20 = f6:CreateFontString(nil,"OVERLAY","GameFontNormal")

local t30 = f8:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t31 = f8:CreateFontString(nil,"OVERLAY","GameFontNormal")
local t32 = f8:CreateFontString(nil,"OVERLAY","GameFontNormal")

local pMissCount = 0
local pSwingAmount, pSwingCount = 0, 0
local pRangeAmount, pRangeCount = 0, 0
local pSpellAmount, pSpellCount = 0, 0
local pDamageAmount, pDamageCount = 0,0

local pHealAmount, pHealCount = 0, 0
local tHealAmount, tHealCount = 0, 0
local sHealAmount, sHealCount = 0, 0

local pGearAmount, pGearCount = 0, 0
local pGearArea, pStatArea = "Gear", "Stats"
local pAttribArea, pAttribStat = "Name", ""
local qText, xText, eText = " ", " ", " "

local function GetToolText(toolLink)
	local _, _, cStatID = UnitClass("player")
	local cTypeUsed = select(6, GetItemInfo(toolLink))
	local cToolText = {}
	local cToolStat = ""
	local isItem = 0
	if(cTypeUsed == "Weapon") then isItem = 1 end
	if(cTypeUsed == "Armor") then isItem = 1 end
	if(isItem == 1) then
		GetItemStats(toolLink, cToolText)
		local ptoolAgi, ptoolStr, ptoolInt, ptoolSta = 0, 0, 0, 0
		for lp, rp in pairs(cToolText) do
			if(lp == "ITEM_MOD_STRENGTH_SHORT") then ptoolStr = rp end
			if(lp == "ITEM_MOD_AGILITY_SHORT") then ptoolAgi = rp end
			if(lp == "ITEM_MOD_INTELLECT_SHORT") then ptoolInt = rp end
			if(lp == "ITEM_MOD_STAMINA_SHORT") then ptoolSta = rp end
		end
		if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", ptoolAgi) .. " Armor" end
		if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", math.floor(ptoolInt * 15)) .. " Mana" end
		if(ptoolSta > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", math.floor(ptoolSta * 10)) .. " Health" end
		if(cStatID == 1) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 2)) .. " Attack" end
			if(math.floor(ptoolStr / 20) > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", math.floor(ptoolStr / 20)) .. " Block" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 1)) .. " Ranged Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
		end
		if(cStatID == 2) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 2)) .. " Attack" end
			if(math.floor(ptoolStr / 20) > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", math.floor(ptoolStr / 20)) .. " Block" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 54)) .. " Spell Crit" end
		end
		if(cStatID == 3) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 2)) .. " Ranged Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 53)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 26)) .. " Dodge" end
		end
		if(cStatID == 4) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 1)) .. " Ranged Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 29)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 14.5)) .. " Dodge" end
		end
		if(cStatID == 5) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 59.2)) .. " Spell Crit" end 
		end
		if(cStatID == 7) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 2)) .. " Attack" end
			if(math.floor(ptoolStr / 20) > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", math.floor(ptoolStr / 20)) .. " Block" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 59.5)) .. " Spell Crit" end 
		end
		if(cStatID == 8) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 1)) .. " Attack" end 
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 59.5)) .. " Spell Crit" end 
		end
		if(cStatID == 9) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 60.6)) .. " Spell Crit" end
		end
		if(cStatID == 11) then
			if(ptoolStr > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolStr * 2)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.0f", (ptoolAgi * 1)) .. " Attack" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Crit" end
			if(ptoolAgi > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolAgi / 20)) .. " Dodge" end 
			if(ptoolInt > 0) then cToolStat = cToolStat .. "\n+" .. format("%.2f%%", (ptoolInt / 60)) .. " Spell Crit" end
		end
	end
	return cToolStat
end

local function GetPartyStat(statID, viewID)
	local p1Health = UnitHealth(statID)
	local p1Mana = UnitPower(statID)
	local p1ManaMax = UnitPowerMax(statID)
	local p1HeathMax = UnitHealthMax(statID)
	local pv1Text = 
	viewID:SetText(format("%.0f", ((p1Health / p1HeathMax) * 100)) .. "\n" .. format("%.0f", ((p1Mana / p1ManaMax) * 100)))
	return pv1Text
end

local function GetPlayerDist(pID)
	local fCheck = CheckInteractDistance(pID, 4)
	local mCheck = CheckInteractDistance(pID, 2)
	local nCheck = CheckInteractDistance(pID, 3)
	if(pID == "player") then return " " end
	if(nCheck == true) then return "< 8 yds" end
	if(mCheck == true) then return "< 10 yds" end
	if(fCheck == true) then return "8 yds - 28 yds" end
	return "28 - ? yds"
end

local function GetPlayerStat(partyID, TitleID, BannerID)
	local pName = UnitName(partyID)
	local pUsedTarget, pUsedRealm = UnitName("playertargettarget")
	local pTargetName = ""
	if(pUsedTarget ~= nil) then pTargetName = "Is targeting " .. pUsedTarget end
	if(pName ~= nil) then
		local pHealth = UnitHealth(partyID)
		local pMana = UnitPower(partyID)
		local pRange = GetPlayerDist(partyID)
		local pText = pRange .. "\n" .. pName .. "\n" .. "Power" .. "\n" .. pTargetName
		local pvText = pHealth .. "\n" .. pMana
		TitleID:SetText(pText)
		BannerID:SetText(pvText)
	end
end

local function GetAllTargets(numUsed)
	local statusParty = ""
	if(numUsed < 6) then
		for t=1,4 do
			local partyName, partyRealm = UnitName("party" .. t)
			local partyTarget, TargetRealm = UnitName("party" .. t .. "target")
			local ptTarget, ptRealm = UnitName("party" .. t .. "targettarget")
			local atDist = GetPlayerDist("party" .. t .. "target")
			local pFound = 0
			if(partyName ~= nil) then
				if(partyTarget ~= nil) then 
					if(ptTarget ~= nil) then
						statusParty = statusParty .. "\n" .. partyName .. " target " .. partyTarget .. " is targeting " .. ptTarget .. " approx. " .. atDist
						pFound = 1
					end
				end
			end
			if(pFound == 0) then statusParty = statusParty .. "\n" .. "P" .. t .. " has no targets." end
		end
	end
	if(numUsed > 5) then
		for t=1,9 do
			local partyName, partyRealm = UnitName("raid" .. t)
			local partyTarget, TargetRealm = UnitName("raid" .. t .. "target")
			local ptTarget, ptRealm = UnitName("raid" .. t .. "targettarget")
			local atDist = GetPlayerDist("party" .. t .. "target")
			local pFound = 0
			if(partyName ~= nil) then
				if(partyTarget ~= nil) then 
					if(ptTarget ~= nil) then
						statusParty = statusParty .. "\n" .. partyName .. " target " .. partyTarget .. " is targeting " .. ptTarget .. " approx. " .. atDist
						pFound = 1
					end
				end
			end
			if(pFound == 0) then statusParty = statusParty .. "\n" .. "R" .. t .. " has no targets." end
		end
	end
	t18:SetText(statusParty)
end

local function UpdatePartyStats()
	local pGroupNum = GetNumGroupMembers()
	GetPlayerStat("player",t10,t11)
	GetPlayerStat("target",t12,t13)
	GetAllTargets(pGroupNum)
	if(pGroupNum < 6) then
		if(pGroupNum > 1) then GetPartyStat("party1",b12); end
		if(pGroupNum > 2) then GetPartyStat("party2",b13); end
		if(pGroupNum > 3) then GetPartyStat("party3",b14); end
		if(pGroupNum > 4) then GetPartyStat("party4",b15); end
	end
	if(pGroupNum > 5) then
		if(pGroupNum > 1) then GetPartyStat("raid1",b12); end
		if(pGroupNum > 2) then GetPartyStat("raid2",b13); end
		if(pGroupNum > 3) then GetPartyStat("raid3",b14); end
		if(pGroupNum > 4) then GetPartyStat("raid4",b15); end
		if(pGroupNum > 5) then GetPartyStat("raid5",b16); end
		if(pGroupNum > 6) then GetPartyStat("raid6",b17); end
		if(pGroupNum > 7) then GetPartyStat("raid7",b18); end
		if(pGroupNum > 8) then GetPartyStat("raid8",b19); end
		if(pGroupNum > 9) then GetPartyStat("raid9",b20); end
	end
	if(pGroupNum < 2) then b12:SetText("P1"); end
	if(pGroupNum < 3) then b13:SetText("P2"); end
	if(pGroupNum < 4) then b14:SetText("P3"); end
	if(pGroupNum < 5) then b15:SetText("P4"); end
	if(pGroupNum < 6) then b16:SetText("P5"); end
	if(pGroupNum < 7) then b17:SetText("P6"); end
	if(pGroupNum < 8) then b18:SetText("P7"); end
	if(pGroupNum < 9) then b19:SetText("P8"); end
	if(pGroupNum < 10) then b20:SetText("P9"); end
end

local function UpdateSpellCast(upID, tID, sID, bID)
	local upUsed, tUsed, sUsed = "","",""
	bID:SetAttribute("shift-macrotext" .. upID, "/target " .. tID .. "\n/cast " .. sID) 
end

local function UpdateSpellIcon(spID, bID)
	local iArea = bID:CreateTexture(nil,"OVERLAY")
	local _, _, iSpell, _, _, _, _ = GetSpellInfo(spID)
	iArea:SetTexture(iSpell)
	iArea:SetPoint("CENTER")
	iArea:SetSize(32,32)
end

local function UpdateClassSpells()
	local _, _, pclassID = UnitClass("player")
	local scOne, scTwo, scThree, scFour, pCastToUse = "Attack","Attack","Attack","Attack","Attack"
	if(pclassID == 2) then
		scOne = "Light of Dawn"
		scTwo = "Holy Shock"
		scThree = "Cleanse Toxins"
		scFour = "Flash of Light"
		local pCaster = IsSpellKnown(20217, false)
		if(pCaster == true) then pCastToUse = scThree end
		if(pCaster == false) then pCastToUse = scOne end
	end
	if(pclassID == 5) then
		scOne = "Power Word: Fortitude"
		scTwo = "Renew"
		scThree = "Flash Heal"
		scFour = "Lesser Heal"
		pCastToUse = scOne
	end
	if(pclassID == 8) then
		scOne = "Arcane Intellect"
		scTwo = "Frost Armor"
		scThree = "Arcane Intellect"
		scFour = "Frost Armor"
		pCastToUse = scOne
	end
	if(pclassID == 11) then
		scOne = "Mark of the Wild"
		scTwo = "Regrowth"
		scThree = "Healing Touch"
		scFour = "Moonfire"
		pCastToUse = scOne
	end	
	if(UnitAffectingCombat("player") == false) then
		local gSpellUsed = GetNumGroupMembers()
		if(gSpellUsed > 5) then
			UpdateSpellCast("1","player",pCastToUse,b1)
			UpdateSpellCast("1","raid1",pCastToUse,b12)
			UpdateSpellCast("1","raid2",pCastToUse,b13)
			UpdateSpellCast("1","raid3",pCastToUse,b14)
			UpdateSpellCast("1","raid4",pCastToUse,b15)
			UpdateSpellCast("1","raid5",pCastToUse,b16)
			UpdateSpellCast("1","raid6",pCastToUse,b17)
			UpdateSpellCast("1","raid7",pCastToUse,b18)
			UpdateSpellCast("1","raid8",pCastToUse,b19)
			UpdateSpellCast("1","raid9",pCastToUse,b20)
			UpdateSpellCast("2","player",scTwo,b1)
			UpdateSpellCast("2","raid1",scTwo,b12)
			UpdateSpellCast("2","raid2",scTwo,b13)
			UpdateSpellCast("2","raid3",scTwo,b14)
			UpdateSpellCast("2","raid4",scTwo,b15)
			UpdateSpellCast("2","raid5",scTwo,b16)
			UpdateSpellCast("2","raid6",scTwo,b17)
			UpdateSpellCast("2","raid7",scTwo,b18)
			UpdateSpellCast("2","raid8",scTwo,b19)
			UpdateSpellCast("2","raid9",scTwo,b20)
		end
		if(gSpellUsed < 6) then
			UpdateSpellCast("1","player",pCastToUse,b1)
			UpdateSpellCast("1","party1",pCastToUse,b12)
			UpdateSpellCast("1","party2",pCastToUse,b13)
			UpdateSpellCast("1","party3",pCastToUse,b14)
			UpdateSpellCast("1","party4",pCastToUse,b15)
			UpdateSpellCast("2","player",scTwo,b1)
			UpdateSpellCast("2","party1",scTwo,b12)
			UpdateSpellCast("2","party2",scTwo,b13)
			UpdateSpellCast("2","party3",scTwo,b14)
			UpdateSpellCast("2","party4",scTwo,b15)
		end
		b40:SetAttribute("macrotext1","/targetfriend")
		b40:SetAttribute("macrotext2","/cast " .. scFour)
		b40:SetAttribute("shift-macrotext1","/cast " .. pCastToUse)
		b40:SetAttribute("shift-macrotext2","/cast " .. scTwo)
		UpdateSpellIcon(pCastToUse, b40)
	end
end

local function VendorGray()
	local i,j,xSold = 0,0,0
	repeat
		local gSlots = GetContainerNumSlots(i)
		if(gSlots ~= nil) then
			j = 1
			repeat
				local gItemLink = GetContainerItemLink(i, j)
				if(gItemLink ~= nil) then
					local _,_,gQuality = GetItemInfo(gItemLink)
					if(gQuality ~= nil) then
						if(gQuality == 0) then UseContainerItem(i,j) ; xSold = xSold + 1 end
					end
				end
				j = j + 1
			until(j > gSlots)
		end
		i = i + 1
	until(i > 4)
	DEFAULT_CHAT_FRAME:AddMessage("Sold " .. xSold .. " gray items.")
end

local function SendStatus(self, ...)
	local playerUsed = UnitGUID("player")
	local targetUsed = UnitGUID("target")
	local _, peventtype, _, psourceGUID, _, _, _, pdestGUID, _, _, _ = ...
	if(psourceGUID == playerUsed) then
		if(peventtype == "SWING_DAMAGE") then
			local pamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSwingCount = pSwingCount + 1 ; pSwingAmount = pSwingAmount + pamount
		end
		if(peventtype == "SPELL_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + pspellamount
		end
		if(peventtype == "SPELL_PERIODIC_DAMAGE") then
			local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pSpellCount = pSpellCount + 1 ; pSpellAmount = pSpellAmount + pspellamount
		end
		if(peventtype == "RANGE_DAMAGE") then
			local _, _, _, prangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
			pRangeCount = pRangeCount + 1 ; pRangeAmount = pRangeAmount + prangeamount
		end

		if(peventtype == "SWING_MISSED") then pMissCount = pMissCount + 1 end
		if(peventtype == "SPELL_MISSED") then pMissCount = pMissCount + 1 end
		if(peventtype == "RANGE_MISSED") then pMissCount = pMissCount + 1 end

		if(pdestGUID == playerUsed) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pHealCount = pHealCount + 1 ; pHealAmount = pHealAmount + pspellamount
			end
		end
		if(pdestGUID ~= playerUsed) then
			if(peventtype == "SPELL_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + pspellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, pspellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				tHealCount = tHealCount + 1 ; tHealAmount = tHealAmount + pspellamount
			end
		end
	end
	if(psourceGUID ~= playerUsed) then
		if(pdestGUID == playerUsed) then
			if(peventtype == "SWING_DAMAGE") then
				local amount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + amount
			end
			if(peventtype == "SPELL_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_DAMAGE") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + spellamount
			end
			if(peventtype == "RANGE_DAMAGE") then
				local _, _, _, rangeamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				pDamageCount = pDamageCount + 1 ; pDamageAmount = pDamageAmount + rangeamount
			end

			if(peventtype == "SWING_MISSED") then pDamageCount = pDamageCount + 1 end
			if(peventtype == "SPELL_MISSED") then pDamageCount = pDamageCount + 1 end
			if(peventtype == "RANGE_MISSED") then pDamageCount = pDamageCount + 1 end

			if(peventtype == "SPELL_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
			if(peventtype == "SPELL_PERIODIC_HEAL") then
				local _, _, _, spellamount, _, _, _, _, _, _, _, _, _ = select(12, ...)
				sHealCount = sHealCount + 1 ; sHealAmount = sHealAmount + spellamount
			end
		end
	end
end

local function UpdateGearView(gearName, gearLevel, gearRare)
	local gearStat = 0
	local gearTitle = "Item"
	if(gearLevel == nil) then gearStat = 0 end
	if(gearLevel ~= nil) then gearStat = gearLevel end
	if(gearName == nil) then gearTitle = "Item" end
	if(gearLevel ~= nil) then gearTitle = gearName end
	gearTitle = "\124cFFFFFFFF" .. gearTitle .. "\124r"
	pGearArea = pGearArea .. "\n" .. gearTitle
	pStatArea = pStatArea .. "\n" .. gearStat
	pGearCount = pGearCount + 1
	pGearAmount = pGearAmount + gearStat
end

local function UpdateSlotGear(gearUpdate)
	local pitemLink = GetInventoryItemLink("player", GetInventorySlotInfo(gearUpdate))
	if(pitemLink ~= nil) then local wName, _, wRare, wLvl = GetItemInfo(pitemLink) ; UpdateGearView(wName, wLvl) end
end

local function UpdateGear()
	pGearCount, pGearAmount = 0, 0
	pGearArea, pStatArea = "Gear", "Stat"
	UpdateSlotGear("MainHandSlot")
	UpdateSlotGear("SecondaryHandSlot")
	UpdateSlotGear("HeadSlot")
	UpdateSlotGear("NeckSlot")
	UpdateSlotGear("ShoulderSlot")
	UpdateSlotGear("BackSlot")
	UpdateSlotGear("ChestSlot")
	UpdateSlotGear("WristSlot")
	UpdateSlotGear("HandsSlot")
	UpdateSlotGear("WaistSlot")
	UpdateSlotGear("LegsSlot")
	UpdateSlotGear("FeetSlot")
	UpdateSlotGear("Finger0Slot")
	UpdateSlotGear("Finger1Slot")
	UpdateSlotGear("Trinket0Slot")
	UpdateSlotGear("Trinket1Slot")
	pGearArea = pGearArea .. "\n" .. "Equipped"
	if(pGearCount > 0) then pStatArea = pStatArea .. "\n" .. format("%.0f", (pGearAmount / pGearCount)) end
end

local function UpdateTextStat(saLeft, saRight)
	local upLeft, upRight = "", ""
	if(saLeft ~= nil) then upLeft = saLeft end
	if(saRight ~= nil) then upRight = saRight end
	pAttribArea = pAttribArea .. "\n" .. upLeft
	pAttribStat = pAttribStat .. "\n" .. upRight
end

local function GetCombatHit(hType)
	local crActual = GetCombatRating(hType)
	local crBonus = GetCombatRatingBonus(hType)
	local crHit = 0
	if(hType == 6) then crHit = GetHitModifier() end
	if(hType == 7) then crHit = GetSpellHitModifier() end
	if(hType == 8) then crHit = GetHitModifier() end
	if(crActual == nil) then crActual = 0 end
	if(crBonus == nil) then crBonus = 0 end
	if(crHit == nil) then crHit = 0 end
	return (crActual + crBonus + crHit)
end

local function UpdateStats()
	local _, _, cStatID = UnitClass("player")
	local pCrit = format("%.2f%%", GetCritChance())
	local sCrit = format("%.2f%%", GetSpellCritChance())
	local rCrit = format("%.2f%%", GetRangedCritChance())
	local rBlock = format("%.2f%%", GetBlockChance())
	local rDodge = format("%.2f%%", GetDodgeChance())
	local rMeleeHit = format("%.2f%%", GetCombatHit(6))
	local rSpellHit = format("%.2f%%", GetCombatHit(7))
	local rRangeHit = format("%.2f%%", GetCombatHit(8))
	local rParry = format("%.2f%%", GetParryChance())
	local rHealRaw = format("%.0f", GetSpellBonusHealing())
	local pHit, base = GetManaRegen()
	local cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	local bPwr, pPwr, nPwr = UnitAttackPower("player")
	local rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	local ePwr = bPwr + pPwr + nPwr
	local rePwr = rbPwr + rpPwr + rnPwr
	local _, pStr, _, _ = UnitStat("player",1)
	local _, pAgi, _, _ = UnitStat("player",2)
	local _, pSta, _, _ = UnitStat("player",3)
	local _, pInt, _, _ = UnitStat("player",4)
	pAttribArea, pAttribStat = " ", " "
	UpdateTextStat("Attack",ePwr)
	UpdateTextStat("Ranged",rePwr)
	UpdateTextStat("Healing",rHealRaw)
	UpdateTextStat("","")
	UpdateTextStat("Block",rBlock)
	UpdateTextStat("Dodge",rDodge)
	UpdateTextStat("Parry",rParry)
	UpdateTextStat("","")
	UpdateTextStat("Melee Hit",rMeleeHit)
	UpdateTextStat("Melee Crit",pCrit)
	UpdateTextStat("Spell Hit",rSpellHit)
	UpdateTextStat("Spell Crit",sCrit)
	UpdateTextStat("Ranged Hit",rRangeHit)
	UpdateTextStat("Ranged Crit",rCrit)
	UpdateTextStat("","")
	UpdateTextStat("Mana Regen",format("%.2f", (base * 2)))
	UpdateTextStat("Mana Regen",format("%.2f", (pHit * 2)))
	UpdateTextStat("","")
	UpdateTextStat("Move Speed",format("%.2f", cSpeed))
	UpdateTextStat("","")
	UpdateTextStat("Stamina","")
	UpdateTextStat("+Health",format("%.0f", (pSta * 10)))
	UpdateTextStat("","")
	UpdateTextStat("Agility","")
	UpdateTextStat("+Armor",format("%.0f", pAgi))
	if(cStatID == 1) then
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 2) then
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 54)))
	end
	if(cStatID == 3) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 2)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 53)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 26)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 4) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Ranged Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 29)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 14.5)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
	end
	if(cStatID == 5) then
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.2)))
	end
	if(cStatID == 7) then
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("+Block",format("%.0f", math.floor(pStr / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.5)))
	end
	if(cStatID == 8) then
		UpdateTextStat("+Dodge",format("%.0f%%", math.floor(pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 59.5)))
	end
	if(cStatID == 9) then
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 1)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 60.6)))
	end
	if(cStatID == 11) then
		UpdateTextStat("+Attack",format("%.0f", (pAgi * 1)))
		UpdateTextStat("+Crit",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("+Dodge",format("%.2f%%", (pAgi / 20)))
		UpdateTextStat("","")
		UpdateTextStat("Strength","")
		UpdateTextStat("+Attack",format("%.0f", (pStr * 2)))
		UpdateTextStat("","")
		UpdateTextStat("Intellect","")
		UpdateTextStat("+Spell Crit",format("%.2f%%", (pInt / 60)))
	end
	UpdateTextStat("+Mana",format("%.0f", math.floor(pInt * 15)))
	UpdateTextStat("","")
end

local function UpdateCombat()	
	local pTotalAvg, pSwingAvg, pRangeAvg, pSpellAvg = 0, 0, 0, 0
	local pDamageAvg, pHealAvg, tHealAvg, sHealAvg, pHealTotalAvg = 0, 0, 0, 0, 0

	local pTotalAmount = pSpellAmount + pSwingAmount + pRangeAmount
	local pTotalCount = pSpellCount + pSwingCount + pRangeCount + pMissCount

	local pHealTotalAmount = pHealAmount + tHealAmount + sHealAmount
	local pHealTotalCount = pHealCount + tHealCount + sHealCount
	
	local vText = " \nMissed\nSwing\nSpell\nRange\nAttacks\n\nHealed\nHealing\nHealers\nHeals\n\nDamage"
	local lText = format("%8s", "Hits")
	local kText = format("%8s", "Avg")
	local gText = format("%8s", "Total")
	
	if(pSwingCount > 0) then pSwingAvg = (pSwingAmount / pSwingCount); end
	if(pRangeCount > 0) then pRangeAvg = (pRangeAmount / pRangeCount); end
	if(pSpellCount > 0) then pSpellAvg = (pSpellAmount / pSpellCount); end
	if(pTotalCount > 0) then pTotalAvg = (pTotalAmount / pTotalCount); end

	if(pHealCount > 0) then pHealAvg = (pHealAmount / pHealCount); end
	if(tHealCount > 0) then tHealAvg = (tHealAmount / tHealCount); end
	if(sHealCount > 0) then sHealAvg = (sHealAmount / sHealCount); end
	if(pHealTotalCount > 0) then pHealTotalAvg = (pHealTotalAmount / pHealTotalCount); end

	if(pDamageCount > 0) then pDamageAvg = pDamageAmount / pDamageCount end

	lText = lText .. "\n" .. format("%8d", pMissCount)
	lText = lText .. "\n" .. format("%8d", pSwingCount)
	lText = lText .. "\n" .. format("%8d", pSpellCount)
	lText = lText .. "\n" .. format("%8d", pRangeCount)
	lText = lText .. "\n" .. format("%8d", pTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pHealCount)
	lText = lText .. "\n" .. format("%8d", tHealCount)
	lText = lText .. "\n" .. format("%8d", sHealCount)
	lText = lText .. "\n" .. format("%8d", pHealTotalCount)

	lText = lText .. "\n"
	lText = lText .. "\n" .. format("%8d", pDamageCount)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pSwingAvg)
	kText = kText .. "\n" .. format("%8d", pSpellAvg)
	kText = kText .. "\n" .. format("%8d", pRangeAvg)
	kText = kText .. "\n" .. format("%8d", pTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pHealAvg)
	kText = kText .. "\n" .. format("%8d", tHealAvg)
	kText = kText .. "\n" .. format("%8d", sHealAvg)
	kText = kText .. "\n" .. format("%8d", pHealTotalAvg)

	kText = kText .. "\n"
	kText = kText .. "\n" .. format("%8d", pDamageAvg)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pSwingAmount)
	gText = gText .. "\n" .. format("%10d", pSpellAmount)
	gText = gText .. "\n" .. format("%10d", pRangeAmount)
	gText = gText .. "\n" .. format("%10d", pTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pHealAmount)
	gText = gText .. "\n" .. format("%10d", tHealAmount)
	gText = gText .. "\n" .. format("%10d", sHealAmount)
	gText = gText .. "\n" .. format("%10d", pHealTotalAmount)

	gText = gText .. "\n"
	gText = gText .. "\n" .. format("%10d", pDamageAmount)

	t3:SetText(vText)
	t5:SetText(lText)
	t8:SetText(kText)
	t9:SetText(gText)
end

local function UpdateZoneText(tZone, lZone, MZone)
	qText = qText .. "\n" .. tZone
	xText = xText .. "\n" .. lZone
	eText = eText .. "\n" .. MZone
end

local function UpdateExperience()
	local pLvl = UnitLevel("player")
	local pExp = UnitXP("player")
	local pExpMax = UnitXPMax("player")
	local tExp = pExpMax - pExp
	local pXPLvl = ((pLvl * 5) + 45)
	local tExpCount = tExp / pXPLvl
	qText, xText, eText = "", "", ""
	UpdateZoneText("NPC Level " .. pLvl .. " (" .. pXPLvl .. " xp)","-",format("%.0f", tExpCount))
	UpdateZoneText("Experience","-",tExp)
	UpdateZoneText(" "," "," ")
end

local function UpdateZone()
	local pLvl = UnitLevel("player")
	UpdateZoneText("Zone","Lvl","Max")
	UpdateZoneText(" "," "," ")
	if(pLvl < 10) then 
		UpdateZoneText("Dun Morogh","1","10")
		UpdateZoneText("Durotar","1","10")
		UpdateZoneText("Elwynn Forest","1","10")
		UpdateZoneText("Mulgore","1","10")
		UpdateZoneText("Teldrassil","1","10")
		UpdateZoneText("Tirisfal Glades","1","10")
	end
	if(pLvl > 9) then
		if(pLvl < 21) then
			UpdateZoneText("Darkshore","10","20")
			UpdateZoneText("Loch Modan","10","20")
			UpdateZoneText("Silverpine Forest","10","20")
			UpdateZoneText("Westfall","10","20")
		end
	end
	if(pLvl > 14) then
		if(pLvl < 26) then UpdateZoneText("Redridge Mountains","15","25") end
		if(pLvl < 28) then UpdateZoneText("Stonetalon Mountains","15","27") end
	end

	if(pLvl > 17) then
		if(pLvl < 31) then UpdateZoneText("Ashenvale","18","30") end
		if(pLvl < 31) then UpdateZoneText("Duskwood","18","30") end
	end

	if(pLvl > 19) then
		if(pLvl < 31) then UpdateZoneText("Hillsbrad Foothills","20","30") end
		if(pLvl < 31) then UpdateZoneText("Wetlands","20","30") end
	end

	if(pLvl > 24) then
		if(pLvl < 36) then UpdateZoneText("Thousand Needles","25","35") end
	end

	if(pLvl > 29) then
		if(pLvl < 46) then UpdateZoneText("Stranglethorn Vale","30","45") end
	end

	if(pLvl > 34) then
		if(pLvl < 46) then UpdateZoneText("Duskwallow Marsh","35","45") end
		if(pLvl < 46) then UpdateZoneText("Badlands","35","45") end 
		if(pLvl < 46) then UpdateZoneText("Swamp of Sorrows","35","45") end 
	end

	if(pLvl > 29) then
		if(pLvl < 41) then UpdateZoneText("Alterac Mountains","30","40") end
		if(pLvl < 41) then UpdateZoneText("Arathi Highlands","30","40") end
		if(pLvl < 41) then UpdateZoneText("Desolace","30","40") end
	end

	if(pLvl > 39) then
		if(pLvl < 51) then UpdateZoneText("Feralas","40","50") end 
		if(pLvl < 51) then UpdateZoneText("Hinterlands","40","50") end
		if(pLvl < 51) then UpdateZoneText("Tanaris","40","50") end
	end

	if(pLvl > 44) then 
		if(pLvl < 51) then UpdateZoneText("Searing Gorge","45","50") end
		if(pLvl < 56) then UpdateZoneText("Azshara","45","55") end
		if(pLvl < 56) then UpdateZoneText("Blasted Lands","45","55") end
	end

	if(pLvl > 47) then 
		if(pLvl < 56) then UpdateZoneText("Un'goro Crater","48","55") end
		if(pLvl < 56) then UpdateZoneText("Felwood","48","55") end
	end

	if(pLvl > 49) then 
		if(pLvl < 59) then UpdateZoneText("Burning Steppes","50","58") end
	end

	if(pLvl > 50) then 
		if(pLvl < 59) then UpdateZoneText("Western Plaguelands","51","58") end
	end

	if(pLvl > 52) then
		if(pLvl < 61) then UpdateZoneText("Eastern Plaguelands","53","60") end
		if(pLvl < 61) then UpdateZoneText("Winterspring","53","60") end
	end

	if(pLvl > 58) then
		if(pLvl < 61) then UpdateZoneText("Deadwind Pass","59","60") end
		if(pLvl < 61) then UpdateZoneText("Moonglade","59","60") end
		if(pLvl < 61) then UpdateZoneText("Silithus","59","60") end
	end
	UpdateZoneText(" "," "," ")
end

local function UpdateDungeon()
	local dLvl = UnitLevel("player")
	UpdateZoneText("Dungeon","Lvl","Boss")
	UpdateZoneText(" "," "," ")
	if(dLvl > 12) then
		if(dLvl < 19) then UpdateZoneText("Orgrimmar","","") ; UpdateZoneText("RFC Ragefire Chasm","13","16") ; UpdateZoneText("","","") end
	end

	if(dLvl > 16) then
		if(dLvl < 24) then UpdateZoneText("Westfall","","") ; UpdateZoneText("VC The Deadmines VC","17","21") ; UpdateZoneText("","","") end
        	if(dLvl < 25) then UpdateZoneText("The Barrens","","") ; UpdateZoneText("WC Wailing Caverns WC","18","22") ; UpdateZoneText("","","") end
        	if(dLvl < 29) then UpdateZoneText("Silverpine Forest","","") ; UpdateZoneText("SFK Shadowfang Keep SFK","18","26") ; UpdateZoneText("","","") end
	end

	if(dLvl > 19) then
		if(dLvl < 31) then UpdateZoneText("Ashenvale","","") ; UpdateZoneText("\124cFF00FF00BFD Blackfathom Deeps BFD\124r","22","28") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 20) then
		if(dLvl < 32) then UpdateZoneText("Stormwind","","") ; UpdateZoneText("\124cFF00FF00STOCKS The Stockade\124r","21","29") ; UpdateZoneText("","","") end
	end

	if(dLvl > 21) then
        	if(dLvl < 37) then UpdateZoneText("Dun Morogh","","") ; UpdateZoneText("\124cFF00FF00GNOMER Gnomeregan\124r","22","34") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 22) then
		if(dLvl < 36) then UpdateZoneText("The Barrens","","") ; UpdateZoneText("\124cFF00FF00RFK Razorfen Kraul\124r","25","33") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 28) then
		if(dLvl < 37) then UpdateZoneText("Tirisfal Glades","","") ; UpdateZoneText("\124cFF00FF00SMGY Scarlet Monastery Graveyard\124r","30","34") ; UpdateZoneText("","","") end
	end

	if(dLvl > 31) then
        	if(dLvl < 40) then UpdateZoneText("Tirisfal Glades","","") ; UpdateZoneText("\124cFF00FF00SMLIB Scarlet Monastery Library\124r","34","37") ; UpdateZoneText("","","") end
	end

	if(dLvl > 33) then
		if(dLvl < 44) then UpdateZoneText("The Barrens","","") ; UpdateZoneText("\124cFF00FF00RFD Razorfen Down\124r","35","41") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 43) then UpdateZoneText("Tirisfal Glades","","") ; UpdateZoneText("\124cFF00FF00SMARMS Scarlet Monastery Armory\124r","36","39") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 45) then UpdateZoneText("Tirisfal Glades","","") ; UpdateZoneText("\124cFF00FF00SMCATH Scarlet Monastery Cathedral\124r","37","42") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 34) then
		if(dLvl < 50) then UpdateZoneText("Badlands","","") ; UpdateZoneText("\124cFF00FF00ULDA Uldaman\124r","37","47") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 40) then
		if(dLvl < 51) then UpdateZoneText("Tanaris","","") ; UpdateZoneText("\124cFF00FF00ZF Zul'Farrak\124r","43","48") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 40) then
		if(dLvl < 53) then UpdateZoneText("Desolace","","") ; UpdateZoneText("\124cFF00FF00MARA Maraudon\124r","43","51") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 44) then
		if(dLvl < 58) then UpdateZoneText("Swamp of Sorrows","","") ; UpdateZoneText("\124cFF00FF00ST Temple of Atal'Hakkar\124r","47","55") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 45) then
		if(dLvl < 61) then UpdateZoneText("Burning Steppes","","") ; UpdateZoneText("\124cFF00FF00BRD Blackrock Depths\124r","48","59") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 51) then 
		if(dLvl < 61) then UpdateZoneText("Burning Steppes","","") ; UpdateZoneText("\124cFF00FF00LBRS Lower Blackrock Spire\124r","54","60") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 51) then 
		if(dLvl < 61) then UpdateZoneText("Feralas","","") ; UpdateZoneText("\124cFF00FF00DM Dire maul\124r","55","41") ; UpdateZoneText("","","") end
		if(dLvl < 61) then UpdateZoneText("Burning Steppes","","") ; UpdateZoneText("\124cFF00FF00UBRS Upper Blackrock Spire Raid 10\124r","55","62") ; UpdateZoneText("","","") end
	end
    
	if(dLvl > 52) then 
		if(dLvl < 61) then 
			UpdateZoneText("Eastern Plaguelands","","")
			UpdateZoneText("\124cFF00FF00STRAT Stratholme\124r" ,"56","62") ; UpdateZoneText("","","") 
		end
	end

	if(dLvl > 53) then 
		if(dLvl < 61) then UpdateZoneText("Western Plaguelands","","") ; UpdateZoneText("\124cFF00FF00SCHOLO Scholomance\124r","57","62") ; UpdateZoneText("","","") end
	end
	UpdateZoneText(" "," "," ")
end

local function UpdateQuestInfo()
	local tGold = 0
	local nEntries, nQuests = GetNumQuestLogEntries()
	qText, xText, eText = "", "", ""
	UpdateZoneText("Quests","Gold","Level")
	UpdateZoneText(" "," "," ")
	for i=1, nEntries do
		local qTitle, qLevel, _, qHeader, _, _, _, qID, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
		if(qHeader == true) then UpdateZoneText(qTitle,"","") end
		if(qHeader == false) then 
			local qMoney = GetQuestLogRewardMoney(qID)
			local qLB = GetNumQuestLeaderBoards(i)
			local nTitle = "\124cFF00FF00" .. qTitle .. "\124r"
			UpdateZoneText(nTitle,GetCoinTextureString(qMoney, 8),qLevel)
			for z=1, qLB do
				local tQuest, _, _ = GetQuestLogLeaderBoard(z,i)
				local hTitle = "\124cFFFFFFFF" .. tQuest .. "\124r"
				if(tQuest ~= nil) then UpdateZoneText(" -" .. hTitle,"","") end
			end
			tGold = tGold + qMoney
			UpdateZoneText(" "," "," ")
		end
	end
	UpdateZoneText(" "," "," ")
	UpdateZoneText("Total Gold",GetCoinTextureString(tGold, 8),"-")
	t30:SetText(qText)
	t31:SetText(xText)
	t32:SetText(eText)
end

local function IconButton(bUsed, iUsed)
	local iArea = bUsed:CreateTexture(nil,"OVERLAY")
	iArea:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcon_" .. iUsed)
	iArea:SetPoint("CENTER")
	iArea:SetSize(24,24)
end

local function GetRaidIcons()
	for i=1,8 do
		if(i == 1) then IconButton(b4, 1) end
		if(i == 2) then IconButton(b5, 2) end
		if(i == 3) then IconButton(b6, 3) end
		if(i == 4) then IconButton(b7, 4) end
		if(i == 5) then IconButton(b8, 5) end
		if(i == 6) then IconButton(b9, 6) end
		if(i == 7) then IconButton(b10, 7) end
		if(i == 8) then IconButton(b11, 8) end
	end
end

local function ShowStats()
	UpdatePartyStats()
	UpdateCombat()
end

local function ShowGear()
	UpdateStats()
	UpdateGear()
	t1:SetText(pGearArea) ; t2:SetText(pStatArea)
	t19:SetText(pAttribArea) ; t20:SetText(pAttribStat)
end

local function ShowQuesting()
	UpdateExperience()
	UpdateZone()
	UpdateDungeon()
	t6:SetText(qText)
	t16:SetText(xText)
	t17:SetText(eText)
	UpdateQuestInfo()
end

local function ResetAllAreas()
    	pMissCount = 0
    	pSwingAmount, pSwingCount = 0, 0
    	pRangeAmount, pRangeCount = 0, 0
    	pSpellAmount, pSpellCount = 0, 0
    	pDamageAmount, pDamageCount = 0,0

    	pHealAmount, pHealCount = 0, 0
    	tHealAmount, tHealCount = 0, 0
    	sHealAmount, sHealCount = 0, 0

    	pGearAmount, pGearCount = 0, 0
    	pGearArea, pStatArea = "Gear", "Stats"
	pAttribArea, pAttribStat = "Gear", "Stats"
	qText, xText, eText = "", "", ""

    	if(MerchantFrame:IsVisible() == false) then b3:Hide() end
	ShowStats(); f2:Show()
    	ShowGear() ; f1:Show()
    	ShowQuesting() ; f3:Show()
	f5:Show() ; f6:Show() ; f4:Show() ; f9:Show()
end

b1:EnableMouse(true)
b1:SetMovable(true)
b1:SetClampedToScreen(true)
b1:RegisterForClicks("AnyDown")
b1:RegisterForDrag("RightButton")
b1:SetScript("OnDragStart", b1.StartMoving)
b1:SetScript("OnDragStop", b1.StopMovingOrSizing)
b1:SetAttribute("type1", "target")
b1:SetAttribute("shift-type1", "macro")
b1:SetAttribute("shift-type2", "macro")
b1:SetAttribute("unit","player")
b1:SetPoint("TOPLEFT",10,20)
b1:SetSize(320, 80)

t10:SetPoint("TOPLEFT",10, -10)
t10:SetWidth(300)
t10:SetHeight(60)
t10:SetJustifyH("LEFT")
t10:SetTextColor(1,0,0,1)

t11:SetPoint("TOPLEFT",10, -10)
t11:SetWidth(300)
t11:SetHeight(60)
t11:SetJustifyH("RIGHT")
t11:SetTextColor(1,1,1,1)

b2:EnableMouse(true)
b2:SetMovable(true)
b2:SetClampedToScreen(true)
b2:RegisterForDrag("RightButton")
b2:SetScript("OnDragStart", b2.StartMoving)
b2:SetScript("OnDragStop", b2.StopMovingOrSizing)
b2:RegisterForClicks("AnyUp")
b2:SetAttribute("type1", "macro")
b2:SetAttribute("shift-type1", "macro")
b2:SetAttribute("macrotext1", "/cleartarget\n/stopcasting\n/stopattack\n/targetenemy [noexists][dead]\n/startattack")
b2:SetAttribute("shift-macrotext1", "/cleartarget\n/stopcasting\n/stopattack\n/say is not attacking")
b2:SetPoint("TOPLEFT",340,20)
b2:SetSize(320, 80)

t12:SetPoint("TOPLEFT",10, -10)
t12:SetWidth(300)
t12:SetHeight(60)
t12:SetJustifyH("LEFT")
t12:SetTextColor(1,0,0,1)

t13:SetPoint("TOPLEFT",10, -10)
t13:SetWidth(300)
t13:SetHeight(60)
t13:SetJustifyH("RIGHT")
t13:SetTextColor(1,1,1,1)

f1:SetWidth(420)
f1:SetHeight(400)
f1:SetAlpha(.90)
f1:SetPoint("CENTER",-330,0)
f1:SetMovable(true)
f1:EnableMouse(true)
f1:SetClampedToScreen(true)
f1:RegisterForDrag("RightButton")
f1:SetScript("OnDragStart", f1.StartMoving)
f1:SetScript("OnDragStop", f1.StopMovingOrSizing)

t1:SetPoint("TOPLEFT", 10, -10)
t1:SetWidth(400)
t1:SetHeight(380)
t1:SetJustifyH("LEFT")

t2:SetPoint("TOPLEFT", 10, -10)
t2:SetWidth(400)
t2:SetHeight(380)
t2:SetJustifyH("RIGHT")
t2:SetTextColor(1,1,1,1)

f2:SetWidth(420)
f2:SetHeight(260)
f2:SetAlpha(.90)
f2:SetPoint("CENTER", 0, 0)
f2:SetMovable(true)
f2:EnableMouse(true)
f2:SetClampedToScreen(true)
f2:RegisterForDrag("RightButton")
f2:SetScript("OnDragStart", f2.StartMoving)
f2:SetScript("OnDragStop", f2.StopMovingOrSizing)

t3:SetPoint("TOPLEFT",10, -10)
t3:SetWidth(70)
t3:SetHeight(240)
t3:SetJustifyH("RIGHT")

t5:SetPoint("TOPLEFT", 90, -10)
t5:SetWidth(90)
t5:SetHeight(240)
t5:SetJustifyH("RIGHT")

t8:SetPoint("TOPLEFT", 190, -10)
t8:SetWidth(90)
t8:SetHeight(240)
t8:SetJustifyH("RIGHT")

t9:SetPoint("TOPLEFT", 290, -10)
t9:SetWidth(110)
t9:SetHeight(240)
t9:SetJustifyH("RIGHT")

f3:SetWidth(480)
f3:SetHeight(640)
f3:SetAlpha(.90)
f3:SetPoint("CENTER",330,0)
f3:SetMovable(true)
f3:EnableMouse(true)
f3:SetClampedToScreen(true)
f3:RegisterForDrag("RightButton")
f3:SetScript("OnDragStart", f3.StartMoving)
f3:SetScript("OnDragStop", f3.StopMovingOrSizing)

t6:SetPoint("TOPLEFT", 10, -10)
t6:SetWidth(460)
t6:SetHeight(620)
t6:SetJustifyH("LEFT")

t16:SetPoint("TOPLEFT", 240, -10)
t16:SetWidth(140)
t16:SetHeight(620)
t16:SetJustifyH("RIGHT")
t16:SetTextColor(1,1,1,1)

t17:SetPoint("TOPLEFT", 10, -10)
t17:SetWidth(460)
t17:SetHeight(620)
t17:SetJustifyH("RIGHT")
t17:SetTextColor(1,1,1,1)

f4:SetWidth(340)
f4:SetHeight(320)
f4:SetAlpha(.90)
f4:SetPoint("CENTER",0,-170)
f4:EnableMouse(true)
f4:SetMovable(true)
f4:SetClampedToScreen(true)
f4:RegisterForDrag("RightButton")
f4:SetScript("OnDragStart", f4.StartMoving)
f4:SetScript("OnDragStop", f4.StopMovingOrSizing)

b4:SetWidth(40)
b4:SetHeight(40)
b4:SetPoint("TOPLEFT",10,-26)
b4:EnableMouse(true)
b4:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 1); end
end)

b5:SetWidth(40)
b5:SetHeight(40)
b5:SetPoint("TOPLEFT",50,-26)
b5:EnableMouse(true)
b5:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 2); end
end)

b6:SetWidth(40)
b6:SetHeight(40)
b6:SetPoint("TOPLEFT",90,-26)
b6:EnableMouse(true)
b6:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 3); end
end)

b7:SetWidth(40)
b7:SetHeight(40)
b7:SetPoint("TOPLEFT",130,-26)
b7:EnableMouse(true)
b7:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 4); end
end)

b8:SetWidth(40)
b8:SetHeight(40)
b8:SetPoint("TOPLEFT",170,-26)
b8:EnableMouse(true)
b8:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 5); end
end)

b9:SetWidth(40)
b9:SetHeight(40)
b9:SetPoint("TOPLEFT",210,-26)
b9:EnableMouse(true)
b9:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 6); end
end)

b10:SetWidth(40)
b10:SetHeight(40)
b10:SetPoint("TOPLEFT",250,-26)
b10:EnableMouse(true)
b10:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 7); end
end)

b11:SetWidth(40)
b11:SetHeight(40)
b11:SetPoint("TOPLEFT",290,-26)
b11:EnableMouse(true)
b11:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then SetRaidTarget("target", 8); end
end)

b12:SetWidth(80)
b12:SetHeight(80)
b12:EnableMouse(true)
b12:RegisterForClicks("AnyUp")
b12:SetAttribute("type1", "target")
b12:SetAttribute("shift-type1", "macro")
b12:SetAttribute("shift-type2", "macro")
b12:SetAttribute("unit","party1")
b12:SetPoint("TOPLEFT",10,-66)
b12:SetText("P2")
b12:SetNormalFontObject("GameFontNormal")

b13:SetWidth(80)
b13:SetHeight(80)
b13:EnableMouse(true)
b13:RegisterForClicks("AnyUp")
b13:SetAttribute("type1", "target")
b13:SetAttribute("shift-type1", "macro")
b13:SetAttribute("shift-type2", "macro")
b13:SetAttribute("unit","party2")
b13:SetPoint("TOPLEFT",90,-66)
b13:SetText("P3")
b13:SetNormalFontObject("GameFontNormal")

b14:SetWidth(80)
b14:SetHeight(80)
b14:EnableMouse(true)
b14:RegisterForClicks("AnyUp")
b14:SetAttribute("type1", "target")
b14:SetAttribute("shift-type1", "macro")
b14:SetAttribute("shift-type2", "macro")
b14:SetAttribute("unit","party3")
b14:SetPoint("TOPLEFT",170,-66)
b14:SetText("P4")
b14:SetNormalFontObject("GameFontNormal")

b15:SetWidth(80)
b15:SetHeight(80)
b15:EnableMouse(true)
b15:RegisterForClicks("AnyUp")
b15:SetAttribute("type1", "target")
b15:SetAttribute("shift-type1", "macro")
b15:SetAttribute("shift-type2", "macro")
b15:SetAttribute("unit","party4")
b15:SetPoint("TOPLEFT",10,-146)
b15:SetText("P5")
b15:SetNormalFontObject("GameFontNormal")

b16:SetWidth(80)
b16:SetHeight(80)
b16:EnableMouse(true)
b16:RegisterForClicks("AnyUp")
b16:SetAttribute("type1", "target")
b16:SetAttribute("shift-type1", "macro")
b16:SetAttribute("shift-type2", "macro")
b16:SetAttribute("unit","raid5")
b16:SetPoint("TOPLEFT",90,-146)
b16:SetText("P6")
b16:SetNormalFontObject("GameFontNormal")

b17:SetWidth(80)
b17:SetHeight(80)
b17:EnableMouse(true)
b17:RegisterForClicks("AnyUp")
b17:SetAttribute("type1", "target")
b17:SetAttribute("shift-type1", "macro")
b17:SetAttribute("shift-type2", "macro")
b17:SetAttribute("unit","raid6")
b17:SetPoint("TOPLEFT",170,-146)
b17:SetText("P7")
b17:SetNormalFontObject("GameFontNormal")

b18:SetWidth(80)
b18:SetHeight(80)
b18:EnableMouse(true)
b18:RegisterForClicks("AnyUp")
b18:SetAttribute("type1", "target")
b18:SetAttribute("shift-type1", "macro")
b18:SetAttribute("shift-type2", "macro")
b18:SetAttribute("unit","raid7")
b18:SetPoint("TOPLEFT",10,-226)
b18:SetText("P8")
b18:SetNormalFontObject("GameFontNormal")

b19:SetWidth(80)
b19:SetHeight(80)
b19:EnableMouse(true)
b19:RegisterForClicks("AnyUp")
b19:SetAttribute("type1", "target")
b19:SetAttribute("shift-type1", "macro")
b19:SetAttribute("shift-type2", "macro")
b19:SetAttribute("unit","raid8")
b19:SetPoint("TOPLEFT",90,-226)
b19:SetText("P9")
b19:SetNormalFontObject("GameFontNormal")

b20:SetWidth(80)
b20:SetHeight(80)
b20:EnableMouse(true)
b20:RegisterForClicks("AnyUp")
b20:SetAttribute("type1", "target")
b20:SetAttribute("shift-type1", "macro")
b20:SetAttribute("shift-type2", "macro")
b20:SetAttribute("unit","raid9")
b20:SetPoint("TOPLEFT",170,-226)
b20:SetText("P10")
b20:SetNormalFontObject("GameFontNormal")

b40:SetWidth(80)
b40:SetHeight(80)
b40:EnableMouse(true)
b40:RegisterForClicks("AnyUp")
b40:SetAttribute("type1", "macro")
b40:SetAttribute("type2", "macro")
b40:SetAttribute("shift-type1", "macro")
b40:SetAttribute("shift-type2", "macro")
b40:SetPoint("TOPLEFT",250,-66)
b40:SetNormalFontObject("GameFontNormal")

f7:SetWidth(420)
f7:SetHeight(60)
f7:SetAlpha(.90)
f7:SetPoint("CENTER",0,-170)
f7:EnableMouse(true)
f7:SetMovable(true)
f7:SetClampedToScreen(true)
f7:RegisterForDrag("RightButton")
f7:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f7:RegisterEvent("MERCHANT_SHOW")
f7:RegisterEvent("MERCHANT_CLOSED")
f7:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE")
f7:RegisterEvent("QUEST_DETAIL")
f7:RegisterEvent("UNIT_INVENTORY_CHANGED")
f7:RegisterEvent("GROUP_ROSTER_UPDATE")
f7:RegisterEvent("RAID_ROSTER_UPDATE")
f7:RegisterEvent("UNIT_HEALTH_FREQUENT")
f7:RegisterEvent("UNIT_HEALTH_FREQUENT")
f7:RegisterEvent("UNIT_POWER_FREQUENT")
f7:RegisterEvent("UNIT_TARGET")
f7:RegisterEvent("UNIT_COMBAT")
f7:SetScript("OnEvent", function(self, event, ...)
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then SendStatus(self, CombatLogGetCurrentEventInfo()) ; ShowStats() end
	if(event == "MERCHANT_SHOW") then b3:Show() end
	if(event == "MERCHANT_CLOSED") then b3:Hide() end
	if(event == "QUEST_DETAIL") then AcceptQuest() end
	if(event == "UNIT_HEALTH_FREQUENT") then ShowStats() end
	if(event == "UNIT_POWER_FREQUENT") then ShowStats() end
	if(event == "UNIT_TARGET") then ShowStats() end
	if(event == "PLAYER_AVG_ITEM_LEVEL_UPDATE") then ShowGear() end
	if(event == "PLAYER_EQUIPMENT_CHANGED") then ShowGear() end
	if(event == "UNIT_INVENTORY_CHANGED") then ShowGear() end
	if(event == "GROUP_ROSTER_UPDATE") then ShowStats() ; UpdateClassSpells() ; end
	if(event == "RAID_ROSTER_UPDATE") then ShowStats() ; UpdateClassSpells() ; end
end)
f7:SetScript("OnDragStart", f7.StartMoving)
f7:SetScript("OnDragStop", f7.StopMovingOrSizing)

b3:SetWidth(40)
b3:SetHeight(40)
b3:SetPoint("TOPLEFT",290,-10)
b3:EnableMouse(true)
b3:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then VendorGray(); end
end)
b3:SetText("$")
b3:SetNormalFontObject("GameFontNormalTiny")

b21:SetWidth(40)
b21:SetHeight(40)
b21:EnableMouse(true)
b21:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowStats() ; f2:Show() end 
end)
b21:SetPoint("TOPLEFT",10,-10)
b21:SetText("A")
b21:SetNormalFontObject("GameFontNormal")

b22:SetWidth(40)
b22:SetHeight(40)
b22:EnableMouse(true)
b22:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowQuesting() ; f3:Show() end 
end)
b22:SetPoint("TOPLEFT",50,-10)
b22:SetText("Q")
b22:SetNormalFontObject("GameFontNormal")

b23:SetWidth(40)
b23:SetHeight(40)
b23:EnableMouse(true)
b23:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); f1:Show() end 
end)
b23:SetPoint("TOPLEFT",130,-10)
b23:SetText("C")
b23:SetNormalFontObject("GameFontNormal")

b24:SetWidth(40)
b24:SetHeight(40)
b24:EnableMouse(true)
b24:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); f5:Show() end 
end)
b24:SetPoint("TOPLEFT",90,-10)
b24:SetText("T")
b24:SetNormalFontObject("GameFontNormal")

b25:SetWidth(40)
b25:SetHeight(40)
b25:EnableMouse(true)
b25:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then ShowGear(); f6:Show() end 
end)
b25:SetPoint("TOPLEFT",170,-10)
b25:SetText("S")
b25:SetNormalFontObject("GameFontNormal")

b26:SetWidth(40)
b26:SetHeight(40)
b26:EnableMouse(true)
b26:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f4:Show() end 
end)
b26:SetPoint("TOPLEFT",250,-10)
b26:SetText("+")
b26:SetNormalFontObject("GameFontNormal")

b27:SetWidth(40)
b27:SetHeight(40)
b27:EnableMouse(true)
b27:SetScript("OnMouseDown", function (self, button) 
	if(button == "LeftButton") then f9:Show() end 
end)
b27:SetPoint("TOPLEFT",210,-10)
b27:SetText("i")
b27:SetNormalFontObject("GameFontNormal")

f5:SetWidth(420)
f5:SetHeight(150)
f5:SetAlpha(.90)
f5:SetPoint("CENTER", 0, 0)
f5:SetMovable(true)
f5:EnableMouse(true)
f5:SetClampedToScreen(true)
f5:RegisterForDrag("RightButton")
f5:SetScript("OnDragStart", f5.StartMoving)
f5:SetScript("OnDragStop", f5.StopMovingOrSizing)

t18:SetPoint("TOPLEFT",5, -5)
t18:SetWidth(410)
t18:SetHeight(140)
t18:SetJustifyH("LEFT")

f6:SetWidth(420)
f6:SetHeight(520)
f6:SetAlpha(.90)
f6:SetPoint("CENTER",0,0)
f6:SetMovable(true)
f6:EnableMouse(true)
f6:SetClampedToScreen(true)
f6:RegisterForDrag("RightButton")
f6:SetScript("OnDragStart", f6.StartMoving)
f6:SetScript("OnDragStop", f6.StopMovingOrSizing)

t19:SetPoint("TOPLEFT", 10, -10)
t19:SetWidth(400)
t19:SetHeight(500)
t19:SetJustifyH("LEFT")

t20:SetPoint("TOPLEFT", 10, -10)
t20:SetWidth(400)
t20:SetHeight(500)
t20:SetJustifyH("RIGHT")
t20:SetTextColor(1,1,1,1)

f9:SetWidth(500)
f9:SetHeight(300)
f9:SetAlpha(.90)
f9:SetPoint("CENTER", 0, 0)
f9:SetMovable(true)
f9:EnableMouse(true)
f9:SetClampedToScreen(true)
f9:RegisterForDrag("RightButton")
f9:SetScript("OnDragStart", f9.StartMoving)
f9:SetScript("OnDragStop", f9.StopMovingOrSizing)

f8:SetWidth(480)
f8:SetHeight(1080)
f8:SetPoint("TOPLEFT",0,0)

s2:SetPoint("TOPLEFT",0,-22)
s2:SetSize(472,272)
s2:SetScrollChild(f8)

t30:SetPoint("TOPLEFT",10, -10)
t30:SetWidth(460)
t30:SetJustifyH("LEFT")

t31:SetPoint("TOPLEFT", 240, -10)
t31:SetWidth(140)
t31:SetJustifyH("RIGHT")
t31:SetTextColor(1,1,1,1)

t32:SetPoint("TOPLEFT", 10, -10)
t32:SetWidth(460)
t32:SetJustifyH("RIGHT")
t32:SetTextColor(1,1,1,1)

ShowStats()
ShowGear()
ShowQuesting()
UpdateClassSpells()
GetRaidIcons()

f1:Hide() ; f2:Hide() ; f3:Hide() ; f5:Hide()
f7:Show() ; f6:Hide() ; f4:Hide() ; b3:Hide()
f9:Hide()




